/*
--------------------------------------------------------------------------------------
    VisualApplication v. 0.3
    Copyright (C) 2008 andbad
    andbad@iol.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--------------------------------------------------------------------------------------
*/
#define ND_NOT_MAIN_SOURCE

#include <nanodesktop.h>
#include <stdio.h>

//Dichiarazione delle funzioni globali
ndint64 TheCloseWndCallback (char WndHandle, ndint64 WndInfoField);
ndint64 AboutVisualApplication(char WndHandle);

int YouCanExit, TBoxHandle, OpenExist=0, OptionExist=0, SaveExist=0, ErrRep, AnalogMouse;
char WndHandleVisualOCR;
int MoreInfoVar=0, ListChapesVar=0, ListPatternVar=0, ListAllPatternVar=0, LineInfosVar=0,DebugModeVar=0;
int SpacewidthVar=10, GraylevelVar=100, DustsizeVar=20,UseDatabaseVar=0,LayoutAnalysisVar=0,Compare_modeVar=0, Divide_modeVar=0,ContextCorrectionVar=0,CharPackingVar=0, OnlyNumbersVar=0, SpeechVar=0, SaveVar=0;
struct ndImage_Type Image;
char NameFile[255], FileChoosen[255], command[255], temp[255], NameTXT[255], out[65556];
int ErrorLevel;
int gocr_main(int argn, char *argv[]);



void ScanVisualOCR (char *StringID, ndint64 InfoField, char WndHandle)
{
     char command[255];
     if (strlen(NameFile))
     {
        int v=0, m=0;
        remove(&NameTXT);
        strcat(&command, " -i ");
        strcat(&command, "ms0:/temp.pnm");
        
        v=MoreInfoVar+ListChapesVar*2+ListPatternVar*4+ListAllPatternVar*8+LineInfosVar*16+DebugModeVar*32;
        strcat(&command, " -v ");
        _itoa(v, &temp, 10);
        strcat(&command, &temp);
        
        m=UseDatabaseVar*2+LayoutAnalysisVar*4+Compare_modeVar*8+Divide_modeVar*16+ContextCorrectionVar*32+CharPackingVar*64;
        strcat(&command, " -m ");
        _itoa(m, &temp, 10);
        strcat(&command, &temp);
        
        strcat(&command, " -l ");
        _itoa(GraylevelVar, &temp, 10);
        strcat(&command, &temp);
        
        strcat(&command, " -d ");
        _itoa(DustsizeVar, &temp, 10);
        strcat(&command, &temp);
        
        strcat(&command, " -s ");
        _itoa(SpacewidthVar, &temp, 10);
        strcat(&command, &temp);
 
        if (OnlyNumbersVar) strcat(&command, " -n 1 ");  
        
        //Esegui la scansione
        pseudoExec (&gocr_main, "gocr", command, &ErrorLevel); 
        
        strcat(&command, " -o ");
	    strcat(&command, &NameTXT);
        pseudoExec (&gocr_main, "gocr", command, &ErrorLevel); 
        printf("%s",command);
     }
     else
     {
        char WndHandleLocal;
        WndHandleLocal=ndLP_CreateWindow (75, 50, 370, 100, "Error", COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, NO_RESIZEABLE);
        ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleLocal);    
        ndLP_PutWindowInFirstPlane(WndHandleLocal);
        ndLP_MaximizeWindow (WndHandleLocal);
        ndWS_GrWriteLn(10,10, "Error: please open a image file!", COLOR_BLUE, COLOR_LBLUE, WndHandleLocal, RENDER);
        ndHAL_Delay(3);
        ndLP_DestroyWindow(WndHandleLocal);      
     }
}

void OpenFileVisualOCR (char *StringID, ndint64 InfoField, char WndHandle)
{
     if (!OpenExist)
     {
        char PathFile[255],ExtFile[4];
        ndIMG_InitImage(&Image);
        OpenExist=1;
        remove("ms0:/temp.pnm");
	    //Richiamo il FileManager per selezionare un file immagine
        FileManager ("Choose a image file for OCR", 0, 0, &FileChoosen);
    
        ErrRep=ndIMG_LoadImage(&Image, &FileChoosen, NDMGKNB);
        
        if (ErrRep) 
        {
             char WndHandleLocal;
             WndHandleLocal=ndLP_CreateWindow (75, 50, 370, 100, "Error", COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, NO_RESIZEABLE);
             ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleLocal);    
             ndLP_PutWindowInFirstPlane(WndHandleLocal);
             ndLP_MaximizeWindow (WndHandleLocal);
             ndWS_GrWriteLn(10,10, "Error loading the image file!", COLOR_BLUE, COLOR_LBLUE, WndHandleLocal, RENDER);
             ndHAL_Delay(3);
             ndLP_DestroyWindow(WndHandleLocal);        
        }
        else 
        {
             //Scrivo il nome del file sull'interfaccia
             fssSplitNameFile(&FileChoosen,PathFile,NameFile,ExtFile);
             strncpy(temp,NameFile,strlen(NameFile));
             strcat(temp,".");
             strcat(temp, ExtFile);
             
             strncpy(NameTXT, PathFile,strlen(PathFile));
             strcat(NameTXT,NameFile);
             strcat(NameTXT, ".txt");
             remove(&NameTXT);
             
             //Copio il nome del file nella textbox
             strncpy ( ndTBOX_GetRowAddr (0, TBoxHandle, WndHandle), temp,strlen(temp));
             ndTBOX_TextAreaUpdate (TBoxHandle, WndHandle, RENDER);
             
             //Salvo l'immagine in formato .pnm per il riconoscimento
             ndIMG_SaveImage(&Image, "ms0:/temp.pnm");
  
        }
        
        OpenExist=0;
    };
    
    ndHAL_Delay(0.15);     
}

void SaveVisualOCR(char *StringID, ndint64 InfoField, char WndHandle)
{
    if (!SaveVar) SaveVar=1;
    ndHAL_Delay(0.15);
}

Spacewidth_Callback (float SpacewidthChange, int TB_InfoField, char WndHandle)
{
       SpacewidthVar=SpacewidthChange;
}

Graylevel_Callback (float GraylevelChange, int TB_InfoField, char WndHandle)
{
       GraylevelVar=GraylevelChange;
}

Dustsize_Callback (float DustsizeChange, int TB_InfoField, char WndHandle)
{
       DustsizeVar=DustsizeChange;
}

ndint64 OptionVisualOCR(char WndHandle)
//Funzione che apre la finestra contenente le opzioni avanzate
{
    if (!OptionExist)
    {
        OptionExist=1;
        char WndHandleLocal;
        WndHandleLocal=ndLP_CreateWindow (100, 50, 340, 180, "Advanced Option", COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, NO_RESIZEABLE);
        ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleLocal);    
        ndLP_PutWindowInFirstPlane(WndHandleLocal);
        ndLP_MaximizeWindow (WndHandleLocal);
         
        ndCBOX_CreateCBox (10, 5, "MoreInfo", MoreInfoVar, 0, &MoreInfoVar, COLOR_LBLUE, 0, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 9, "More info", COLOR_WHITE, COLOR_LBLUE, WndHandleLocal, NORENDER);
        
        ndCBOX_CreateCBox (10, 20, "ListChapes", ListChapesVar, 0, &ListChapesVar, COLOR_LBLUE, 0, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 24, "List chapes", COLOR_WHITE, COLOR_LBLUE, WndHandleLocal, NORENDER);
        
        ndCBOX_CreateCBox (10, 35, "ListPattern", ListPatternVar, 0, &ListPatternVar, COLOR_LBLUE, 0, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 39, "List pattern", COLOR_WHITE, COLOR_LBLUE, WndHandleLocal, NORENDER);
        
        ndCBOX_CreateCBox (10, 50, "ListAllPattern", ListAllPatternVar, 0, &ListAllPatternVar, COLOR_LBLUE, 0, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 54, "List all pattern", COLOR_WHITE, COLOR_LBLUE, WndHandleLocal, NORENDER);
        
        ndCBOX_CreateCBox (10, 65, "LineInfos", LineInfosVar, 0, &LineInfosVar, COLOR_LBLUE, 0, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 69, "Line infos", COLOR_WHITE, COLOR_LBLUE, WndHandleLocal, NORENDER);
        
        ndCBOX_CreateCBox (10, 80, "DebugMode", DebugModeVar, 0, &DebugModeVar, COLOR_LBLUE, 0, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 84, "Debug mode", COLOR_WHITE, COLOR_LBLUE, WndHandleLocal, NORENDER);
        
	    ndCBOX_CreateCBox (10, 95, "Save", SaveVar, 0, &SaveVar, COLOR_LBLUE, 0, WndHandleLocal, NORENDER);
        ndWS_GrWriteLn (30, 99, "Save result on .txt file", COLOR_WHITE, COLOR_LBLUE, WndHandleLocal, NORENDER);

        XWindowRender(WndHandleLocal);
        
        ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0);
        //Uscita dall'applicazione e ritorno alla finestra base
        
        OptionExist=0;
        YouCanExit=0;
        ndLP_DestroyWindow(WndHandleLocal);
    }
}


//Struttura del WinMenu
void WinMenuVisualOCR(char WndHandle)
{
     ndWMENU_DefineMenuItem (WndHandle, "File", "File", 0, 0, NORENDER);
     ndWMENU_DefineMenuItem (WndHandle, "File.Open", "Open...", ND_CALLBACK_IN_NEW_CONTEXT, &OpenFileVisualOCR, NORENDER);
     ndWMENU_DefineMenuItem (WndHandle, "File.Scan", "Scan", ND_CALLBACK_IN_NEW_CONTEXT, &ScanVisualOCR, NORENDER);
     ndWMENU_DefineMenuItem (WndHandle, "File.Save", "Save on .TXT", ND_CALLBACK_IN_NEW_CONTEXT, &SaveVisualOCR, NORENDER);
     ndWMENU_DefineMenuItem (WndHandle, "File.Quit", "Quit", 0, &TheCloseWndCallback, NORENDER);
     
     ndWMENU_DefineMenuItem (WndHandle, "Edit", "Edit", 0, 0, NORENDER);
     ndWMENU_DefineMenuItem (WndHandle, "Edit.Option", "Advanced Option", ND_CALLBACK_IN_NEW_CONTEXT, &OptionVisualOCR, NORENDER);
     ndWMENU_DefineMenuItem (WndHandle, "?", "?", ND_CALLBACK_IN_NEW_CONTEXT, &AboutVisualApplication, NORENDER); 
}




void InterfacciaVisualOCR (int WndHandle)
{
     //Carico i WinMenu
     WinMenuVisualOCR(WndHandle);

     ndCTRL_CreateButton ( 10, 10, 90, 40, WndHandle, "Open", "Open", "File", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE,
                         ND_BUTTON_ROUNDED | ND_CALLBACK_IN_NEW_CONTEXT, &OpenFileVisualOCR, 0, NORENDER );
     ndCTRL_CreateButton ( 95, 10, 170, 40, WndHandle, "Advance", "Advanced", "Option", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 
                         ND_BUTTON_ROUNDED | ND_CALLBACK_IN_NEW_CONTEXT, &OptionVisualOCR, 0, NORENDER );
     
     ndWS_GrWriteLn(10,45, "Spacewidth", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     ndTBAR_CreateTrackBar (10, 55, 165, 75,COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, COLOR_LBLUE, COLOR_WHITE, SpacewidthVar, 0, 200, NDKEY_FONT (1), &Spacewidth_Callback, 0,WndHandle,NORENDER);

     ndWS_GrWriteLn(10,85, "Graylevel", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     ndTBAR_CreateTrackBar (10, 95, 165, 115,COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, COLOR_LBLUE, COLOR_WHITE, GraylevelVar, 0, 255, NDKEY_FONT (1), &Graylevel_Callback, 0,WndHandle,NORENDER);

     ndWS_GrWriteLn(10,125, "Dustsize", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     ndTBAR_CreateTrackBar (10, 135, 165, 155,COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, COLOR_LBLUE, COLOR_WHITE, DustsizeVar, 0, 60, NDKEY_FONT (1), &Dustsize_Callback, 0,WndHandle,NORENDER);
     
     ndCBOX_CreateCBox (175, 10, "UseDatabase", UseDatabaseVar, 0, &UseDatabaseVar, COLOR_LBLUE, 0, WndHandle, NORENDER);
     ndWS_GrWriteLn (192, 14, "Use Database", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     
     ndCBOX_CreateCBox (175, 25, "LayoutAnalysis", LayoutAnalysisVar, 0, &LayoutAnalysisVar, COLOR_LBLUE, 0, WndHandle, NORENDER);
     ndWS_GrWriteLn (192, 29, "Layout analysis", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     
     ndCBOX_CreateCBox (175, 40, "Compare_mode", Compare_modeVar, 0, &Compare_modeVar, COLOR_LBLUE, 0, WndHandle, NORENDER);
     ndWS_GrWriteLn (192, 44, "Not Compare mode", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     
     ndCBOX_CreateCBox (175,55, "Divide_mode", Divide_modeVar, 0, &Divide_modeVar, COLOR_LBLUE, 0, WndHandle, NORENDER);
     ndWS_GrWriteLn (192, 59, "Not Divide mode", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     
     ndCBOX_CreateCBox (175, 70, "ContextCorrection", ContextCorrectionVar, 0, &ContextCorrectionVar, COLOR_LBLUE, 0, WndHandle, NORENDER);
     ndWS_GrWriteLn (192, 74, "Not Context correction", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     
     ndCBOX_CreateCBox (175, 85, "CharPacking", CharPackingVar, 0, &CharPackingVar, COLOR_LBLUE, 0, WndHandle, NORENDER);
     ndWS_GrWriteLn (192, 89, "Char packing", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     
     ndCBOX_CreateCBox (175, 100, "OnlyNumbers", OnlyNumbersVar, 0, &OnlyNumbersVar, COLOR_LBLUE, 0, WndHandle, NORENDER);
     ndWS_GrWriteLn (192, 104, "Only numbers", COLOR_WHITE, COLOR_LBLUE, WndHandle, NORENDER);
     
     // Creo la textbox che conterr il nome del file caricato
     TBoxHandle = ndTBOX_CreateTextArea(10,160,360,185,"NameBox", NDKEY_SETTEXTAREA (41, 2) | ND_TEXTAREA_INHIBITED | NDKEY_FONT (1), 0, COLOR_WHITE, COLOR_LBLUE, COLOR_WHITE, COLOR_LBLUE, COLOR_WHITE, COLOR_LBLUE, NULL, NULL, NULL, 0, WndHandle, NORENDER);
     
     ndCTRL_CreateButton ( 320, 110, 380, 150, WndHandle, "Scan", "Start", "Scan", COLOR_WHITE, COLOR_BLUE, COLOR_WHITE, 
                         ND_BUTTON_ROUNDED, &ScanVisualOCR, 0, NORENDER );
                         
     XWindowRender(WndHandle);
}

void VisualOCR(char *StringID, ndint64 InfoField, char WndHandle)
{
    ndLP_MinimizeWindow (WndHandle);
    //Creazione finestra base
    WndHandleVisualOCR=ndLP_CreateWindow (1, 1, 420, 240, "VisualOCR", COLOR_WHITE, COLOR_BLUE, COLOR_LBLUE, COLOR_WHITE, NO_RESIZEABLE|MENUSUPPORTED);
    ndLP_SetupCloseWndCallback (&TheCloseWndCallback, 0, 0, WndHandleVisualOCR);
    ndLP_PutWindowInFirstPlane(WndHandleVisualOCR);
    ndLP_MaximizeWindow (WndHandleVisualOCR);
    remove("ms0:/temp.pnm");
    
    InterfacciaVisualOCR(WndHandleVisualOCR);
    ndHAL_MouseControlledByAnalog(AnalogMouse);
    ndProvideMeTheMouse_Until (&YouCanExit, ND_IS_EQUAL, 1, 0, 0);
    
    //Uscita dall'applicazione e ritorno alla finestra base
    //Cancello il file immagine temporano
    remove("ms0:/temp.pnm");
    if (SaveVar==0) remove(&NameTXT);
    
    YouCanExit=0;
    ndHAL_Delay(0.5); 
    ndLP_DestroyWindow(WndHandleVisualOCR);
    ndLP_MaximizeWindow(WndHandle);
}
